/* Output from p2c,the Pascal-to-C translator 
	 G. Sawitzki, StatLab Heidelberg 
	(Version MPW 1.20a5/THINK of Nov  6 1992, 23:37:40)
*/
/* From input file "SAM2.PAS" */


#include "p2c.h"


typedef long word;

typedef long byte;

typedef long wordrange;

typedef short byterange;

#define OIN             0
#define IA              1
#define IS              2
#define IM              3
#define IDENT           4
#define FN              5
#define FA              6
#define FS              7
#define FM              8
#define FD              9
#define BI              10
#define BO              11
#define BA              12
#define IC              13
#define FC              14
#define JSR             15
#define BKT             16
#define LD              17
#define STO             18
#define LDA             19
#define FLT             20
#define FIX             21
#define J               22
#define SR              23
#define SL              24
#define RD              25
#define WR              26
#define TRNG            27
#define HALT            28
#define NOP             29
#define CLR             30
#define REALDIR         31
#define STRINGDIR       32
#define INTDIR          33
#define SKIPDIR         34
#define LABELDIR        35

#define noerr           0
#define unkopname       1
#define badregaddr      2
#define badgenaddr      3
#define badint          4
#define badreal         5
#define badstr          6
#define badname         7
#define illregaddr      8
#define illimedaddr     9
#define badshftamt      10
#define badstring       11
#define invalidname     12

#define longname        0
#define missingR        1
#define missingnum      2
#define missingrp       3
#define missingcomma    4
#define namedefined     5
#define badskip         6
#define esctooshort     7
#define strtooshort     8
#define textfollows     9

typedef union icrec {
  word wdf;
  wordrange sintf;
} icrec;

typedef union bcrec {
   byte bytef;
   byterange hintf;
} bcrec;

/* Macintosh under OS X
typedef union bcrec {
   byte bytef;
   struct pad {
   	byterange p1;
   	byterange hintf;
   } pad;
} bcrec;
*/
typedef Char stringtype[25];
typedef Char name[7];

typedef struct symrec {
  name id;
  struct symrec *left, *right;
  short patch, loc;
} symrec;


Static word Inop, Iaop, Isop, Imop, Idop, Fnop, Faop, Fsop, Fmop, Fdop, Biop,
	    Boop, Baop, Icop, Fcop, Jsrop, Bktop, Ldop, Stoop, Ldaop, Fltop,
	    Fixop, Jop, Srop, Slop, Rdop, Wrop, Trngop, Haltop;
Static FILE *InFile;
Static boolean Saved;
Static Char Ch;
#define maxint 8191
Static byte Mem[maxint];
Static long Lc;
Static FILE *memf;
Static symrec *Symbols;
Static short Line;
Static boolean Listing;
Static char Error;
Static boolean Errs, Warning, Morewarn;
Static char Warns[10];
Static short Windex;
Static icrec Icr;
Static bcrec Bcr;
Static short i;
Static stringtype Arg, Memfname, Srcfname;
Static Char InFile_NAME[_FNSIZE];
Static Char memf_NAME[_FNSIZE];


Static void wordtobytes(word w, byte *hibyte, byte *lobyte)
{ short i;

  *lobyte = 0;
  *hibyte = 0;
  for (i = 0; i <= 7; i++)
  { if ((unsigned)i < 32 && ((1L << i) & w) != 0)
      *lobyte |= 1L << i;
    if (i >= -8 && i < 24 && ((1L << (i + 8)) & w) != 0)
      *hibyte |= 1L << i;
  }
}


Static  void bytestoword(byte hibyte, byte lobyte, word *w)
{ short i;

  *w = 0;
  for (i = 0; i <= 7; i++)
  { if ((unsigned)i < 32 && ((1L << i) & lobyte) != 0)
      *w |= 1L << i;
    if ((unsigned)i < 32 && ((1L << i) & hibyte) != 0)
      *w |= 1L << (i + 8);
  }
}


Static void insertmem(word w)
{ byte lobyte, hibyte;

  wordtobytes(w, &hibyte, &lobyte);
  Mem[Lc] = hibyte;
  Mem[Lc + 1] = lobyte;
  Lc += 2;
}


Static void checktab(symrec *cur)
{ if (cur == NULL)
    return;
  checktab(cur->left);
  if (cur->loc < 0)
  { Warning = true;
    printf("WARNING -- %.7s Undefined\n", cur->id);
  }
  checktab(cur->right);
}


Static void warn(char w)
{ if (!Morewarn)
    Windex = 1;
  Morewarn = true;
  Warns[Windex - 1] = w;
  Windex++;
}


Static void printwarn()
{ short i, FORLIM;

  printf("WARNING -- ");
  switch (Warns[0])
  {

  case textfollows:
    printf("Text follows instruction");
    break;

  case esctooshort:
    printf("Need 3 digits to specify an unprintable character");
    break;

  case strtooshort:
    printf("Missing \" in string");
    break;

  case badskip:
    printf("Skip value must be positive, Skip directive ignored");
    break;

  case namedefined:
    printf("Name already defined, earlier definition lost");
    break;

  case longname:
    printf("Name too long, only 7 characters used");
    break;

  case missingR:
    printf("Missing R in Register Address");
    break;

  case missingnum:
    printf("Missing Number in Register Address (0 assumed)");
    break;

  case missingrp:
    printf("Missing \")\" in Indexed Address");
    break;

  case missingcomma:
    printf("Missing \",\"");
    break;
  }
  printf(" on line %d\n", Line);
  FORLIM = Windex;
  for (i = 2; i < FORLIM; i++)
    Warns[i - 2] = Warns[i - 1];
  Windex--;
  if (Windex <= 1)
    Morewarn = false;
}


Static void inregaddr(word *w, short reg, short hbit)
{ if (reg > 7)
  { *w |= 1L << hbit;
    reg -= 8;
  }
  hbit--;
  if (reg > 3)
  { *w |= 1L << hbit;
    reg -= 4;
  }
  hbit--;
  if (reg > 1)
  { *w |= 1L << hbit;
    reg -= 2;
  }
  hbit--;
  if (reg > 0)
    *w |= 1L << hbit;
}


Static void getch()
{ if (Saved)
  { Saved = false;
    return;
  }
  if (P_eof(InFile))
  { Ch = '%';
    return;
  }
  if (P_eoln(InFile))
  { Ch = '%';
    return;
  }
  do
  { Ch = getc(InFile);
    if (Listing)
      putchar(Ch);
  } while (!(Ch != ' ' && Ch != '\t' || P_eoln(InFile)));
  if (Ch != '%')
    return;
  while (!P_eoln(InFile))
  { Ch = getc(InFile);
    if (Listing)
      putchar(Ch);
  }
  Ch = '%';
}


Static void scanname(Char *id)
{ short i;

  for (i = 0; i <= 6; i++)
    id[i] = ' ';
  i = 1;
  while ((Ch == '$' || isalnum(Ch)) && i <= 7)
  { id[i - 1] = Ch;
    i++;
    getch();
  }
  if (Ch == '$' || isalnum(Ch))
    warn(longname);
  while (Ch == '$' || isalnum(Ch))
    getch();
  Saved = true;
}


Static symrec *findname(Char *id)
{ symrec *temp;
  boolean found;

  temp = Symbols;
  found = false;
  while (!found && temp != NULL)
  { if (!strncmp(temp->id, id, sizeof(name)))
    { found = true;
      break;
    }
    if (strncmp(temp->id, id, sizeof(name)) > 0)
      temp = temp->left;
    else
      temp = temp->right;
  }
  return temp;
}


Static symrec *inname(Char *id)
{ symrec *cur, *prev;

  cur = Symbols;
  prev = NULL;
  while (cur != NULL)
  { prev = cur;
	 if (strncmp(cur->id, id, sizeof(name)) > 0)
      cur = cur->left;
    else
      cur = cur->right;
  }
  cur = Malloc(sizeof(symrec));
  cur->left = NULL;
  cur->right = NULL;
  memcpy(cur->id, id, sizeof(name));
  if (prev == NULL)
  { Symbols = cur;
    return cur;
  }
  if (strncmp(prev->id, id, sizeof(name)) > 0)
    prev->left = cur;
  else
    prev->right = cur;
  return cur;
}


typedef union ccrec {
  word wf;
  struct {
    Char c2, c1;
  } U0;
} ccrec;


Static void scanstr()
{ boolean one;
  ccrec ccr;
  short ival;

  one = true;
  getch();
  if (Ch != '"')
  { Error = badstring;
    return;
  }
  if (!P_eoln(InFile))
  { Ch = getc(InFile);
    if (Listing)
      putchar(Ch);
  }
  while (Ch != '"' && !P_eoln(InFile))
  { if (Ch == ':')
    { if (!P_eoln(InFile))
      { Ch = getc(InFile);
	if (Listing)
	  putchar(Ch);
	if (isdigit(Ch))
	{ ival = Ch - '0';
	  if (!P_eoln(InFile))
	  { Ch = getc(InFile);
	    if (Listing)
	      putchar(Ch);
	    if (isdigit(Ch))
	    { ival = ival * 10 + Ch - '0';
	      if (!P_eoln(InFile))
	      { Ch = getc(InFile);
		if (Listing)
		  putchar(Ch);
		if (isdigit(Ch))
		  ival = ival * 10 + Ch - '0';
		else
		  warn(esctooshort);
	      } else
		warn(esctooshort);
	    } else
	      warn(esctooshort);
	  } else
	    warn(esctooshort);
	  Ch = ival;
	}
      } else
	warn(esctooshort);
    }
    if (one)
    { one = false;
      ccr.U0.c1 = Ch;
    } else {
      one = true;
      ccr.U0.c2 = Ch;
      insertmem(ccr.wf);
    }
    if (P_eoln(InFile))
      break;
    Ch = getc(InFile);
    if (Listing)
      putchar(Ch);
  }
  if (one)
    ccr.U0.c1 = '\0';
  else
    ccr.U0.c2 = '\0';
  insertmem(ccr.wf);
  if (Ch != '"')
    warn(strtooshort);
}


typedef long bytetype;

typedef struct mrec {
  byte byte1, byte2, byte3, byte4, byte5, byte6;
} mrec;

typedef union rcrec {
  double rf;
  mrec mf;
} rcrec;


Static void scanreal(word *w1, word *w2)
{ rcrec rcr;
  double dval;

  rcr.rf = 0.0;
  getch();
  while (isdigit(Ch))
  { rcr.rf = rcr.rf * 10 + Ch - '0';
    getch();
  }
  if (Ch == '.')
  { getch();
    dval = 10.0;
    while (isdigit(Ch))
    { rcr.rf += (Ch - '0') / dval;
      dval *= 10.0;
      getch();
    }
  } else
    Saved = true;
  bytestoword(rcr.mf.byte1, rcr.mf.byte4, w1);
  bytestoword(rcr.mf.byte5, rcr.mf.byte6, w2);
}


Static void scanint(word *w)
{ short temp;
  boolean neg;

  neg = false;
  temp = 0;
  getch();
  if (Ch == '+' || Ch == '-')
  { if (Ch == '-')
      neg = true;
    getch();
  }
  while (isdigit(Ch))
  { temp = temp * 10 + Ch - '0';
    getch();
  }
  Saved = true;
  if (neg)
    temp = -temp;
  if (temp > SHORT_MAX || temp < -SHORT_MAX)
    Error = badint;
  else {
    Icr.sintf = temp;
    *w = Icr.wdf;
  }
}


Static short getregaddr()
{ short temp;

  getch();
  if (Ch == 'R')
    getch();
  else
    warn(missingR);
  if (!isdigit(Ch))
  { warn(missingnum);
    return temp;
  }
  temp = Ch - '0';
  getch();
  if (isdigit(Ch))
    temp = temp * 10 + Ch - '0';
  else
    Saved = true;
  if (temp > 15)
    Error = badregaddr;
  return temp;
}


Static void getgenaddr(char op, word *w1, word *w2, boolean *flag)
{ short reg;
  name id;
  symrec *idrec;

  *flag = false;
  getch();
  if (Ch == '*')
  { *w1 |= 0x40;
    getch();
  }
  if (Ch == '$' || Ch >= 'S' && Ch <= 'Z' || Ch >= 'A' && Ch <= 'Q' ||
      islower(Ch))
  { *flag = true;
    scanname(id);
    idrec = findname(id);
    if (idrec == NULL)
    { idrec = inname(id);
      idrec->loc = -1;
      idrec->patch = Lc + 2;
      Icr.sintf = -1;
    } else if (idrec->loc == -1)
    { Icr.sintf = idrec->patch;
      idrec->patch = Lc + 2;
    } else
      Icr.sintf = idrec->loc;
    *w2 = Icr.wdf;
    getch();
    if (Ch != '(')
    { *w1 |= 0x10;
      return;
    }
    *w1 |= 0x20;
    reg = getregaddr();
    if (Error != noerr)
      return;
    inregaddr(w1, reg, 3);
    getch();
    if (Ch != ')')
      warn(missingrp);
    return;
  }
  if (isdigit(Ch))
  { Saved = true;
    *w1 |= 0x10;
    *flag = true;
    scanint(w2);
    return;
  }
  if (Ch != '&' && Ch != '+' && Ch != '-' && Ch != '#' && Ch != 'R')
  { Error = badgenaddr;
    return;
  }
  switch (Ch)
  {

  case 'R':
    *flag = false;
    Saved = true;
    reg = getregaddr();
    inregaddr(w1, reg, 3);
    if ((unsigned long)op < 32 &&
	((1L << ((long)op)) & ((1L << ((long)JSR)) | (1L << ((long)BKT)) |
	   (1L << ((long)LDA)) | (1L << ((long)J)))) != 0 &&
	(0x40 & (*w1)) == 0)
      Error = illregaddr;
    break;

  case '#':
    *flag = true;
    if ((0x40 & (*w1)) != 0)
      Error = badgenaddr;
    else if ((unsigned long)op < 32 &&
	((1L << ((long)op)) & ((1L << ((long)FN)) | (1L << ((long)FA)) |
	      (1L << ((long)FS)) | (1L << ((long)FM)) | (1L << ((long)FD)) |
	      (1L << ((long)FC)) | (1L << ((long)FIX)) | (1L << ((long)JSR)) |
	      (1L << ((long)BKT)) | (1L << ((long)STO)) | (1L << ((long)J)) |
	      (1L << ((long)RD)) | (1L << ((long)TRNG)))) != 0)
      Error = illimedaddr;
    else if (*w1 == (Wrop | 0x80))
      Error = illimedaddr;
    else if (*w1 == (Wrop | 0x480))
      Error = illimedaddr;
    else {
      *w1 |= 0x30;
      scanint(w2);
    }
    break;

  case '-':
  case '+':
    *w1 |= 0x20;
    *flag = true;
    if (Ch == '-')
      Saved = true;
    scanint(w2);
    getch();
    if (Ch == '(')
    { reg = getregaddr();
      if (Error == noerr)
      { inregaddr(w1, reg, 3);
	getch();
	if (Ch != ')')
	  warn(missingrp);
      }
    } else
      Error = badgenaddr;
    break;

  case '&':
    *flag = true;
	 if ((0x40 & (*w1)) != 0)
      Error = badgenaddr;
    else {
      *w1 |= 0x70;
      scanint(w2);
    }
    break;
  }
}


Static void getBop(char *op, word *wd)
{ getch();
  if (Ch != 'O' && Ch != 'K' && Ch != 'I' && Ch != 'A')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'A':
    *op = BA;
    *wd = Baop;
    break;

  case 'I':
    *op = BI;
    *wd = Biop;
    break;

  case 'K':
    getch();
    if (Ch == 'T')
    { *op = BKT;
      *wd = Bktop;
    } else
      Error = unkopname;
    break;

  case 'O':
    *op = BO;
    *wd = Boop;
    break;
  }
}


Static void getFop(char *op, word *wd)
{ getch();
  if (Ch != 'S' && Ch != 'N' && Ch != 'M' && Ch != 'L' && Ch != 'I' &&
      Ch != 'D' && Ch != 'C' && Ch != 'A')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'A':
    *op = FA;
    *wd = Faop;
    break;

  case 'C':
    *op = FC;
    *wd = Fcop;
    break;

  case 'D':
    *op = FD;
    *wd = Fdop;
    break;

  case 'I':
    getch();
    if (Ch == 'X')
    { *op = FIX;
      *wd = Fixop;
    } else
      Error = unkopname;
    break;

  case 'L':
    getch();
    if (Ch == 'T')
    { *op = FLT;
      *wd = Fltop;
    } else
      Error = unkopname;
    break;

  case 'M':
    *op = FM;
    *wd = Fmop;
    break;

  case 'N':
    *op = FN;
    *wd = Fnop;
    break;

  case 'S':
    *op = FS;
    *wd = Fsop;
    break;
  }
}


Static void getIop(char *op, word *wd)
{ getch();
  if (Ch != 'S' && Ch != 'N' && Ch != 'M' && Ch != 'D' && Ch != 'C' &&
      Ch != 'A')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'A':
    *op = IA;
    *wd = Iaop;
    break;

  case 'C':
    *op = IC;
    *wd = Icop;
    break;

  case 'D':
    *op = IDENT;
    *wd = Idop;
    break;

  case 'M':
    *op = IM;
    *wd = Imop;
    break;

  case 'N':
    getch();
    if (Ch == 'T')
      *op = INTDIR;
    else {
      *op = OIN;
      *wd = Inop;
      Saved = true;
    }
    break;

  case 'S':
    *op = IS;
    *wd = Isop;
    break;
  }
}


Static void getJop(char *op, word *wd)
{ getch();
  if (Ch != 'S' && Ch != 'N' && Ch != 'M' && Ch != 'L' && Ch != 'G' &&
      Ch != 'E')
  { Error = unkopname;
    return;
  }
  *op = J;
  switch (Ch)
  {

  case 'E':
    getch();
    if (Ch == 'Q')
      *wd = Jop | 0x180;
    else
      Error = unkopname;
    break;

  case 'G':
    getch();
    if (Ch == 'E')
      *wd = Jop | 0x280;
    else if (Ch == 'T')
      *wd = Jop | 0x300;
    else
      Error = unkopname;
    break;

  case 'L':
    getch();
    if (Ch == 'E')
      *wd = Jop | 0x100;
    else if (Ch == 'T')
      *wd = Jop | 0x80;
    else
      Error = unkopname;
    break;

  case 'M':
    getch();
    if (Ch == 'P')
      *wd = Jop;
    else
      Error = unkopname;
    break;

  case 'N':
    getch();
    if (Ch == 'E')
      *wd = Jop | 0x200;
    else
      Error = unkopname;
    break;

  case 'S':
    getch();
    if (Ch == 'R')
    { *op = JSR;
      *wd = Jsrop;
    } else
      Error = unkopname;
    break;
  }
}


Static void getLop(char *op, word *wd)
{ getch();
  if (Ch != 'D' && Ch != 'A')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'A':
    getch();
    if (Ch == 'B')
    { getch();
      if (Ch == 'E')
      { getch();
	if (Ch == 'L')
	  *op = LABELDIR;
	else
	  Error = unkopname;
      } else
	Error = unkopname;
    } else
      Error = unkopname;
    break;

  case 'D':
    getch();
    if (Ch == 'A')
    { *op = LDA;
      *wd = Ldaop;
    } else {
      *op = LD;
      *wd = Ldop;
      Saved = true;
    }
    break;
  }
}


Static void getRop(char *op, word *wd)
{ getch();
  if (Ch == 'D')
  { *op = RD;
    getch();
    if (Ch != 'S' && Ch != 'O' && Ch != 'N' && Ch != 'I' && Ch != 'H' &&
	Ch != 'F' && Ch != 'C' && Ch != 'B')
    { Error = unkopname;
      return;
    }
    switch (Ch)
    {

    case 'B':
      getch();
      if (Ch == 'D')
	*wd = Rdop | 0x100;
      else if (Ch == 'W')
	*wd = Rdop | 0x180;
      else
	Error = unkopname;
      break;

    case 'C':
      getch();
      if (Ch == 'H')
	*wd = Rdop | 0x400;
      else
	Error = unkopname;
      break;

    case 'F':
      *wd = Rdop | 0x80;
      break;

    case 'H':
      getch();
      if (Ch == 'D')
	*wd = Rdop | 0x300;
      else if (Ch == 'W')
	*wd = Rdop | 0x380;
      else
	Error = unkopname;
      break;

    case 'I':
      *wd = Rdop;
      break;

    case 'N':
      getch();
      if (Ch == 'L')
	*wd = Rdop | 0x580;
      else
	Error = unkopname;
      break;

    case 'O':
      getch();
      if (Ch == 'D')
	*wd = Rdop | 0x200;
      else if (Ch == 'W')
	*wd = Rdop | 0x280;
      else
	Error = unkopname;
      break;

    case 'S':
      getch();
      if (Ch == 'T')
	*wd = Rdop | 0x480;
      else
	Error = unkopname;
      break;
    }
    return;
  }
  if (Ch != 'E')
  { Error = unkopname;
    return;
  }
  getch();
  if (Ch != 'A')
  { Error = unkopname;
    return;
  }
  getch();
  if (Ch == 'L')
    *op = REALDIR;
  else
    Error = unkopname;
}


Static void getSop(char *op, word *wd)
{ getch();
  if (Ch != 'T' && Ch != 'R' && Ch != 'L' && Ch != 'K')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'K':
    getch();
    if (Ch == 'I')
    { getch();
      if (Ch == 'P')
	*op = SKIPDIR;
      else
	Error = unkopname;
    } else
      Error = unkopname;
    break;

  case 'L':
    getch();
    if (Ch == 'Z' || Ch == 'O' || Ch == 'E' || Ch == 'C')
    { *op = SL;
      switch (Ch)
      {

      case 'C':
	getch();
	if (Ch == 'Z' || Ch == 'O' || Ch == 'E' || Ch == 'C')
	{ switch (Ch)
	  {

	  case 'C':
	    *wd = Slop | 0x70;
	    break;

	  case 'E':
	    *wd = Slop | 0x60;
	    break;

	  case 'O':
	    *wd = Slop | 0x50;
	    break;

	  case 'Z':
	    *wd = Slop | 0x40;
	    break;
	  }
	} else {
	  Saved = true;
	  *wd = Slop | 0x30;
	}
	break;

      case 'E':
	*wd = Slop | 0x20;
	break;

      case 'O':
	*wd = Slop | 0x10;
	break;

      case 'Z':
	*wd = Slop;
	break;
      }
    } else
      Error = unkopname;
    break;

  case 'R':
    getch();
    if (Ch == 'Z' || Ch == 'O' || Ch == 'E' || Ch == 'C')
    { *op = SR;
      switch (Ch)
      {

      case 'C':
	getch();
	if (Ch == 'Z' || Ch == 'O' || Ch == 'E' || Ch == 'C')
	{ switch (Ch)
	  {

	  case 'C':
	    *wd = Srop | 0x70;
	    break;

	  case 'E':
	    *wd = Srop | 0x60;
	    break;

	  case 'O':
	    *wd = Srop | 0x50;
	    break;

	  case 'Z':
	    *wd = Srop | 0x40;
	    break;
	  }
	} else {
	  Saved = true;
	  *wd = Srop | 0x30;
	}
	break;

      case 'E':
	*wd = Srop | 0x20;
	break;

      case 'O':
	*wd = Srop | 0x10;
	break;

      case 'Z':
	*wd = Srop;
	break;
      }
    } else
      Error = unkopname;
    break;

  case 'T':
    getch();
    if (Ch == 'O')
    { *op = STO;
      *wd = Stoop;
    } else if (Ch == 'R')
    { getch();
      if (Ch == 'I')
      { getch();
	if (Ch == 'N')
	{ getch();
	  if (Ch == 'G')
	    *op = STRINGDIR;
	  else
	    Error = unkopname;
	} else
	  Error = unkopname;
      } else
	Error = unkopname;
    } else
      Error = unkopname;
    break;
  }
}


Static void getWop(char *op, word *wd)
{ getch();
  if (Ch != 'R')
  { Error = unkopname;
    return;
  }
  *op = WR;
  getch();
  if (Ch != 'S' && Ch != 'O' && Ch != 'N' && Ch != 'I' && Ch != 'H' &&
      Ch != 'F' && Ch != 'C' && Ch != 'B')
  { Error = unkopname;
    return;
  }
  switch (Ch)
  {

  case 'B':
    getch();
    if (Ch == 'D')
      *wd = Wrop | 0x100;
    else if (Ch == 'W')
      *wd = Wrop | 0x180;
    else
      Error = unkopname;
    break;

  case 'C':
    getch();
    if (Ch == 'H')
      *wd = Wrop | 0x400;
    else
      Error = unkopname;
    break;

  case 'F':
    *wd = Wrop | 0x80;
    break;

  case 'H':
    getch();
    if (Ch == 'D')
      *wd = Wrop | 0x300;
    else if (Ch == 'W')
      *wd = Wrop | 0x380;
    else
      Error = unkopname;
    break;

  case 'I':
    *wd = Wrop;
    break;

  case 'N':
    getch();
    if (Ch == 'L')
      *wd = Wrop | 0x580;
    else
      Error = unkopname;
    break;

  case 'O':
    getch();
    if (Ch == 'D')
      *wd = Wrop | 0x200;
    else if (Ch == 'W')
      *wd = Wrop | 0x280;
    else
      Error = unkopname;
    break;

  case 'S':
    getch();
    if (Ch == 'T')
      *wd = Wrop | 0x480;
    else
      Error = unkopname;
    break;
  }
}


Static void proline()
{ word wd, wd2;
  byte b1, b2;
  char op;
  short reg;
  boolean twowds;
  short i1, i2;
  name id;
  symrec *idrec;

  twowds = false;
  Error = noerr;
  if (Ch == 'W' || Ch == 'T' || Ch == 'S' || Ch == 'R' || Ch == 'N' ||
      Ch == 'L' || Ch == 'J' || Ch == 'I' || Ch == 'H' || Ch == 'F' ||
      Ch == 'C' || Ch == 'B')
  { switch (Ch)
    {

    case 'B':
      getBop(&op, &wd);
      break;

    case 'C':
      getch();
      if (Ch == 'L')
      { getch();
	if (Ch == 'R')
	{ op = CLR;
	  wd = Srop;
	} else
	  Error = unkopname;
      } else
	Error = unkopname;
      break;

    case 'F':
      getFop(&op, &wd);
      break;

    case 'H':
      getch();
      if (Ch == 'A')
      { getch();
	if (Ch == 'L')
	{ getch();
	  if (Ch == 'T')
	  { op = HALT;
	    wd = Haltop;
	  } else
	    Error = unkopname;
	} else
	  Error = unkopname;
      } else
	Error = unkopname;
      break;

    case 'I':
      getIop(&op, &wd);
      break;

    case 'J':
      getJop(&op, &wd);
      break;

    case 'L':
      getLop(&op, &wd);
      break;

    case 'N':
      getch();
      if (Ch == 'O')
      { getch();
	if (Ch == 'P')
	{ op = NOP;
	  wd = Jop | 0x380;
	} else
	  Error = unkopname;
      } else
	Error = unkopname;
      break;

    case 'R':
      getRop(&op, &wd);
      break;

    case 'S':
      getSop(&op, &wd);
      break;

    case 'T':
      getch();
      if (Ch == 'R')
      { getch();
	if (Ch == 'N')
	{ getch();
	  if (Ch == 'G')
	  { op = TRNG;
	    wd = Trngop;
	  } else
	    Error = unkopname;
	} else
	  Error = unkopname;
      } else
	Error = unkopname;
      break;

    case 'W':
      getWop(&op, &wd);
      break;
    }
  } else
    Error = unkopname;
  if (Error != noerr)
    return;
  switch (op)
  {

  case CLR:
    reg = getregaddr();
    if (Error == noerr)
    { inregaddr(&wd, reg, 10);
      insertmem(wd);
    }
    break;

  case SL:
  case SR:
    reg = getregaddr();
    if (Error == noerr)
      inregaddr(&wd, reg, 10);
    getch();
    if (Ch != ',')
    { warn(missingcomma);
      Saved = true;
    }
    scanint(&Icr.wdf);
    if (Error == noerr)
    { reg = Icr.sintf;
      if (reg == 16)
	reg = 0;
      if (reg < 16 && reg >= 0)
      { inregaddr(&wd, reg, 3);
	insertmem(wd);
      } else
	Error = badshftamt;
    }
    break;

  case OIN:
  case IA:
  case IS:
  case IM:
  case IDENT:
  case FN:
  case FA:
  case FS:
  case FM:
  case FD:
  case BI:
  case BO:
  case BA:
  case IC:
  case FC:
  case JSR:
  case BKT:
  case LD:
  case STO:
  case LDA:
  case FLT:
  case FIX:
  case TRNG:
    reg = getregaddr();
    if (Error == noerr)
    { inregaddr(&wd, reg, 10);
      getch();
      if (Ch != ',')
      { warn(missingcomma);
	Saved = true;
      }
      getgenaddr(op, &wd, &wd2, &twowds);
      if (Error == noerr)
      { if (twowds)
	{ insertmem(wd);
	  insertmem(wd2);
	} else
	  insertmem(wd);
      }
    }
    break;

  case J:
    getgenaddr(op, &wd, &wd2, &twowds);
    if (Error == noerr)
    { if (twowds)
      { insertmem(wd);
	insertmem(wd2);
      } else
	insertmem(wd);
    }
    break;

  case RD:
  case WR:
    twowds = false;
    if ((0x400 & wd) == 0 || (0x100 & wd) == 0)
      getgenaddr(op, &wd, &wd2, &twowds);
    if (Error == noerr)
    { if (twowds)
      { insertmem(wd);
	insertmem(wd2);
      } else
	insertmem(wd);
    }
    break;

  case NOP:
  case HALT:
    insertmem(wd);
    break;

  case INTDIR:
    scanint(&wd);
    wordtobytes(wd, &Mem[Lc], &Mem[Lc + 1]);
    Lc += 2;
    break;

  case REALDIR:
    scanreal(&wd, &wd2);
    wordtobytes(wd, &Mem[Lc], &Mem[Lc + 1]);
    wordtobytes(wd2, &Mem[Lc + 2], &Mem[Lc + 3]);
    Lc += 4;
    break;

  case SKIPDIR:
    scanint(&wd);
    Icr.wdf = wd;
    i1 = Icr.sintf;
    if (i1 < 0)
      warn(badskip);
    else
      Lc += i1;
    break;

  case STRINGDIR:
    scanstr();
    break;

  case LABELDIR:
    getch();
    if (Ch == '$' || Ch >= 'S' && Ch <= 'Z' || Ch >= 'A' && Ch <= 'Q' ||
	islower(Ch))
    { scanname(id);
      idrec = findname(id);
      if (idrec == NULL)
	idrec = inname(id);
      else {
	if (idrec->loc >= 0)
	  warn(namedefined);
	i1 = idrec->patch;
	Icr.sintf = Lc;
	wordtobytes(Icr.wdf, &b1, &b2);
	while (i1 >= 0)
	{ bytestoword(Mem[i1], Mem[i1 + 1], &Icr.wdf);
	  i2 = Icr.sintf;
	  Mem[i1] = b1;
	  Mem[i1 + 1] = b2;
	  i1 = i2;
	}
      }
      idrec->patch = -1;
      idrec->loc = Lc;
    } else
      Error = invalidname;
    break;
  }
}


Static void initopcodes()
{ Inop = 0;
  Iaop = 0x800;
  Isop = 0x1000;
  Imop = 0x1800;
  Idop = 0x2000;
  Fnop = 0x2800;
  Faop = 0x3000;
  Fsop = 0x3800;
  Fmop = 0x4000;
  Fdop = 0x4800;
  Biop = 0x5000;
  Boop = 0x5800;
  Baop = 0x6000;
  Icop = 0x6800;
  Fcop = 0x7000;
  Jsrop = 0x7800;
  Bktop = 0xffff8000L;
  Ldop = 0xffff8800;
  Stoop = 0xffff9000;
  Ldaop = 0xffff9800;
  Fltop = 0xffffa000;
  Fixop = 0xffffa800;
  Jop = 0xffffb000;
  Srop = 0xffffb800;
  Slop = 0xffffc000;
  Rdop = 0xffffc800;
  Wrop = 0xffffd000;
  Trngop = 0xffffd800;
  Haltop = 0xfffff800;
}


main(int argc, Char *argv[])
{ short FORLIM;

  PASCAL_MAIN(argc, argv);
  memf = NULL;
  InFile = NULL;
  strcpy(InFile_NAME, "codefile");
  if (InFile != NULL)
    InFile = freopen(InFile_NAME, "r", InFile);
  else
    InFile = fopen(InFile_NAME, "r");
  if (InFile == NULL)
    _EscIO(FileNotFound);
  Symbols = NULL;
  initopcodes();
  Line = 1;
  Lc = 0;
  Errs = false;
  Warning = false;
  Saved = false;
  Listing = true;
  if (Listing && !P_eof(InFile))
    printf("\n%4ld: ", Lc);
  while (!P_eof(InFile))
  { getch();
    while (!P_eof(InFile) && (Ch == '%' || Ch == ' '))
    { fscanf(InFile, "%*[^\n]");
      getc(InFile);
      if (Listing && !P_eof(InFile))
	printf("\n%4ld: ", Lc);
      getch();
      Line++;
    }
    if (P_eof(InFile))
      break;
    Error = noerr;
    Morewarn = false;
    proline();
    getch();
    if (Ch != '%' && Ch != ' ')
    { warn(textfollows);
      while (!P_eoln(InFile))
      { Ch = getc(InFile);
	if (Listing)
	  putchar(Ch);
      }
    }
    fscanf(InFile, "%*[^\n]");
    getc(InFile);
    if (Listing && !P_eof(InFile))
      printf("\n%4ld: ", Lc);
    if (Error != noerr)
    { Errs = true;
      printf("ERROR -- ");
      switch (Error)
      {

      case invalidname:
	printf("Invalid Name in Label Directive");
	break;

      case unkopname:
	printf("Unknown Operation or Directive Name");
	break;

      case badstring:
	printf("Improper String Directive -- Missing \"");
	break;

      case badgenaddr:
	printf("Improperly Formed General Address");
	break;

      case badregaddr:
	printf("Register Address Out of Range");
	break;

      case badint:
	printf("Improperly Formed Integer Constant");
	break;

      case badreal:
	printf("Improperly Formed Real Constant");
	break;

      case badstr:
	printf("Improperly Formed String Constant");
	break;

      case badname:
	printf("Improperly Formed Name");
	break;

      case illregaddr:
	printf("Direct Register Address not Permitted");
	break;

      case illimedaddr:
	printf("Immediate Address not Permitted");
	break;

      case badshftamt:
	printf("Shift Amount not in Range");
	break;
      }
      printf(" detected on line %d\n", Line);
    }
    while (Morewarn)
      printwarn();
    Line++;
  }
  checktab(Symbols);
  strcpy(memf_NAME, "OBJ");
  if (memf != NULL)
    memf = freopen(memf_NAME, "w+b", memf);
  else
    memf = fopen(memf_NAME, "w+b");
  if (memf == NULL)
    _EscIO(FileNotFound);
  if (!Errs && !Warning)
  { FORLIM = Lc;
    for (i = 0; i < FORLIM; i++)
    { Bcr.bytef = Mem[i];
      fwrite(&Bcr.hintf, sizeof(byterange), 1, memf);
    }
  }
  if (InFile != NULL)
    fclose(InFile);
  InFile = NULL;
  if (memf != NULL)
    fclose(memf);
  memf = NULL;
  if (InFile != NULL)
    fclose(InFile);
  if (memf != NULL)
    fclose(memf);
  exit(EXIT_SUCCESS);
}



/* End. */

