/* Output from p2c,the Pascal-to-C translator 
	 G. Sawitzki, StatLab Heidelberg 
	(Version MPW 1.20a5/THINK of Nov  6 1992, 23:37:40)
*/
/* From input file "MACC2.PAS" */


#include "p2c.h"

#define MEMSIZ          SHORT_MAX

#define REGSIZ          16

#define INTSIZ          SHORT_MAX

#define dreg            0
#define dmem            1
#define indxd           2
#define immed           3
#define ireg            4
#define imem            5
#define iindxd          6
#define pcrel           7
#define INDENT          0
#define IA              1
#define IS              2
#define IM              3
#define ID              4
#define FN              5
#define FA              6
#define FS              7
#define FM              8
#define FD              9
#define BI              10
#define BO              11
#define BA              12
#define IC              13
#define FC              14
#define JSR             15
#define BKT             16
#define LD              17
#define STO             18
#define LDA             19
#define FLT             20
#define FIX             21
#define J               22
#define SR              23
#define SL              24
#define RD              25
#define WR              26
#define TRNG            27
#define HALT            31


typedef char regaddr;

typedef long memaddr;

typedef long word;

typedef long byte;

typedef long doubleword;

typedef long wordrange;

typedef short byterange;

typedef union icrec {
  word wf;
  wordrange sintf;
} icrec;

typedef union bcrec {
  byte bytef;
  byterange hintf;
} bcrec;

/* Macintosh under OS X
typedef union bcrec {
   byte bytef;
   struct pad {
   	byterange p1;
   	byterange hintf;
   } pad;
} bcrec;
*/
typedef union rcrec {
  double rf;
  struct {
    byte b1, b2, b3, b4, b5, b6;
  } U99;
} rcrec;

typedef union ccrec {
  struct {
    Char c2, c1;
  } U1;
  word wf;
} ccrec;

#define maxint 20000
Static byte Mem[maxint];
Static word Regs[16];
Static memaddr Pc;
Static word Ir;
Static boolean StopProgram, Lt, Eq, Gt;
Static memaddr oldPc;
Static icrec Icr;
Static rcrec Rcr;
Static ccrec Ccr;
Static bcrec Bcr;
Static Char Arg[20], Memfname[20], Dumpfname[20];
Static FILE *Dumpf;
Static boolean MemImage, Trace, Dump;
Static short i, RegIndex;
Static Char Dumpf_NAME[_FNSIZE];


Static void wordtobytes(word w, byte *hibyte, byte *lobyte)
{ short i;

  *lobyte = 0;
  *hibyte = 0;
  for (i = 0; i <= 7; i++)
  { if ((unsigned)i < 32 && ((1L << i) & w) != 0)
		*lobyte |= 1L << i;
    if (i >= -8 && i < 24 && ((1L << (i + 8)) & w) != 0)
      *hibyte |= 1L << i;
  }
}


Static void bytestoword(byte hibyte, byte lobyte, word *w)
{ short i;

  *w = 0;
  for (i = 0; i <= 7; i++)
  { if ((unsigned)i < 32 && ((1L << i) & lobyte) != 0)
      *w |= 1L << i;
    if ((unsigned)i < 32 && ((1L << i) & hibyte) != 0)
      *w |= 1L << (i + 8);
  }
}


Static void wordstodoubleword(word loword, word hiword, doubleword *dw)
{ short i;

  *dw = 0;
  for (i = 0; i <= 15; i++)
  { if ((unsigned)i < 32 && ((1L << i) & loword) != 0)
      *dw |= 1L << i;
    if ((unsigned)i < 32 && ((1L << i) & hiword) != 0)
      *dw |= 1L << (i + 16);
  }
}


Static void doublewordtowords(doubleword dw, word *loword, word *hiword)
{ short i;

  *loword = 0;
  *hiword = 0;
  for (i = 0; i <= 15; i++)
  { if ((unsigned)i < 32 && ((1L << i) & dw) != 0)
      *loword |= 1L << i;
    if (i >= -16 && i < 16 && ((1L << (i + 16)) & dw) != 0)
      *hiword |= 1L << i;
  }
}


Local void showreg(short reg)
{ printf("r%d", reg);
}

Local void showindxd(short r, short a)
{ printf("%d(", a);
  showreg(r);
  putchar(')');
}

Local void showaddr(short location, short mode, short r2, short a2)
{ switch (mode)
  {

  case dreg:
    showreg(r2);
    break;

  case dmem:
    printf("%d", a2);
    break;

  case indxd:
    showindxd(r2, a2);
    break;

  case immed:
    printf("#%d", a2);
    break;

  case ireg:
    putchar('*');
    showreg(r2);
    break;

  case imem:
    printf("*%d", a2);
    break;

  case iindxd:
    putchar('*');
    showindxd(r2, a2);
    break;

  case pcrel:
    printf("&%d", a2);
    break;

  default:
    printf("invalid addressing mode = %d", mode);
	 break;
  }
}


Static void writeinst(short loc, short opcode, short field1, short field2,
		 short field3, short addr2)
{ printf("%5c%5d%5c", ' ', loc, ' ');
  switch (opcode)
  {

  case INDENT:
    printf("in    ");
    break;

  case IA:
    printf("ia    ");
    break;

  case IS:
    printf("is    ");
    break;

  case IM:
    printf("im    ");
    break;

  case ID:
    printf("id    ");
    break;

  case FN:
    printf("fn    ");
    break;

  case FA:
    printf("fa    ");
    break;

  case FS:
    printf("fs    ");
    break;

  case FM:
    printf("fm    ");
    break;

  case FD:
    printf("fd    ");
    break;

  case BI:
    printf("bi    ");
    break;

  case BO:
    printf("bo    ");
    break;

  case BA:
    printf("ba    ");
    break;

  case IC:
    printf("ic    ");
    break;

  case FC:
    printf("fc    ");
    break;

  case JSR:
    printf("jsr   ");
    break;

  case BKT:
    printf("bkt   ");
    break;

  case LD:
    printf("ld    ");
    break;

  case STO:
    printf("sto   ");
    break;

  case LDA:
    printf("lda   ");
    break;

  case FLT:
    printf("flt   ");
    break;

  case FIX:
    printf("fix   ");
    break;

  case J:
    switch (field1)
    {

    case 0:
      printf("jmp   ");
      break;

    case 1:
      printf("jlt   ");
      break;

    case 2:
      printf("jle   ");
      break;

    case 3:
      printf("jeq   ");
      break;

    case 4:
      printf("jne   ");
      break;

    case 5:
      printf("jge   ");
      break;

    case 6:
      printf("jgt   ");
      break;

    case 7:
      printf("nop   ");
      break;

    default:
      printf("invalid jump instruction, type = %d: ", field1);
      break;
    }
    break;

  case SR:
    switch (field2)
    {

    case 0:
      printf("srz   ");
      break;

    case 1:
      printf("sro   ");
      break;

    case 2:
      printf("sre   ");
      break;

    case 3:
      printf("src   ");
      break;

    case 4:
      printf("srcz  ");
      break;

    case 5:
      printf("srco  ");
      break;

    case 6:
      printf("srce  ");
      break;

    case 7:
      printf("srcc  ");
      break;

    default:
      printf("invalid sr instruction, mode = %d: ", field2);
      break;
    }
    break;

  case SL:
    switch (field2)
    {

    case 0:
      printf("slz   ");
      break;

    case 1:
      printf("slo   ");
      break;

    case 2:
      printf("sle   ");
      break;

    case 3:
      printf("slc   ");
      break;

    case 4:
      printf("slcz  ");
      break;

    case 5:
      printf("slco  ");
      break;

    case 6:
      printf("slce  ");
      break;

    case 7:
      printf("slcc  ");
      break;

    default:
      printf("invalid sl instruction, mode = %d: ", field2);
      break;
    }
    break;

  case RD:
    switch (field1)
    {

    case 0:
      printf("rdi   ");
      break;

    case 1:
      printf("rdf   ");
      break;

    case 2:
      printf("rdbd  ");
      break;

    case 3:
      printf("rdbw  ");
      break;

    case 4:
      printf("rdod  ");
      break;

    case 5:
      printf("rdow  ");
      break;

    case 6:
      printf("rdhd  ");
      break;

    case 7:
      printf("rdhw  ");
      break;

    case 8:
      printf("rdch  ");
      break;

    case 9:
      printf("rdst  ");
      break;

    case 10:
      printf("rdin  ");
      break;

    case 11:
      printf("rdln  ");
      break;

    default:
      printf("invalid rd instruction, fmt = %d: ", field1);
      break;
    }
    break;

  case WR:
    switch (field1)
    {

    case 0:
      printf("wri   ");
      break;

    case 1:
      printf("wrf   ");
      break;

    case 2:
      printf("wrbd  ");
      break;

    case 3:
      printf("wrbw  ");
      break;

    case 4:
      printf("wrod  ");
      break;

    case 5:
      printf("wrow  ");
      break;

    case 6:
      printf("wrhd  ");
      break;

    case 7:
      printf("wrhw  ");
      break;

    case 8:
      printf("wrch  ");
      break;

    case 9:
      printf("wrst  ");
      break;

    case 11:
      printf("wrnl  ");
      break;

    default:
      printf("invalid wr instruction, fmt = %d: ", field1);
      break;
    }
    break;

  case TRNG:
    printf("trng  ");
    break;

  case HALT:
    printf("halt  ");
    break;

  default:
    printf("invalid instruction, opcode = %d: ", opcode);
    break;
  }
  if ((unsigned)opcode < 32 &&
      ((1L << opcode) & (((1L << (FLT + 1)) - (1L << INDENT)) | (1L << TRNG))) != 0)
  { showreg(field1);
    printf(", ");
    showaddr(loc, field2, field3, addr2);
  } else if (opcode == J && field1 != 7 || opcode == WR && field1 != 11 ||
	     opcode == RD)
    showaddr(loc, field2, field3, addr2);
  else if ((unsigned)opcode < 32 &&
	   ((1L << opcode) & ((1L << SR) | (1L << SL))) != 0)
  { showreg(field1);
    printf(", ");
    printf("%d", field3);
  }
  putchar('\n');
}


Static void writeboolean(boolean b)
{ if (b)
    printf("TRUE");
  else
    printf("FALSE");
}


Static void displayregs()
{ short i;

  printf("########################################\n");
  printf("  Pc = %ld  Lt = ", Pc);
  writeboolean(Lt);
  printf("  Eq = ");
  writeboolean(Eq);
  printf("  Gt = ");
  writeboolean(Gt);
  putchar('\n');
  for (i = 0; i < REGSIZ; i++)
  { Icr.wf = Regs[i];
    printf("  Reg[%2d] = %5ld", i, Icr.sintf);
    if (((i + 1) & 3) == 0)
      putchar('\n');
  }
  printf("########################################\n");
}


Static void fetchword(word *w)
{ bytestoword(Mem[Pc], Mem[Pc + 1], w);
  Pc = (Pc + 2) % MEMSIZ;
}


Static short eac(short mode, regaddr reg, short *w2)
{ short taddr;

  *w2 = 0;
  switch (mode)
  {

  case dreg:
    taddr = -1;
    break;

  case dmem:
    fetchword(&Icr.wf);
    taddr = Icr.sintf;
    *w2 = taddr;
    break;

  case indxd:
    fetchword(&Icr.wf);
    *w2 = Icr.sintf;
    Icr.wf = Regs[reg];
    taddr = (*w2 + Icr.sintf) % MEMSIZ;
    break;

  case immed:
    taddr = Pc;
    bytestoword(Mem[taddr], Mem[taddr + 1], &Icr.wf);
    *w2 = Icr.sintf;
    Pc = (Pc + 2) % MEMSIZ;
    break;

  case ireg:
    Icr.wf = Regs[reg];
    taddr = Icr.sintf;
    break;

  case imem:
    fetchword(&Icr.wf);
    *w2 = Icr.sintf;
    bytestoword(Mem[*w2], Mem[*w2 + 1], &Icr.wf);
    taddr = Icr.sintf;
    break;

  case iindxd:
    fetchword(&Icr.wf);
    *w2 = Icr.sintf;
    Icr.wf = Regs[reg];
    taddr = (*w2 + Icr.sintf) % MEMSIZ;
    bytestoword(Mem[taddr], Mem[taddr + 1], &Icr.wf);
    taddr = Icr.sintf;
    break;

  case pcrel:
    fetchword(&Icr.wf);
    *w2 = Icr.sintf;
    taddr = (*w2 + Pc) % MEMSIZ;
    break;
  }
  return taddr;
}


Static void twoaddr(short opcode, short r1, short amode, short r2, short *w2)
{ short addr;
  word wd;
  short iop1, iop2, ans;
  double rop1, rop2;
  short i, FORLIM;

  addr = eac(amode, r2, w2);
  if ((unsigned)opcode < 32 &&
      ((1L << opcode) & ((1L << INDENT) | (1L << IA) | (1L << IS) |
			 (1L << IM) | (1L << ID) | (1L << IC))) != 0)
  { if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Icr.wf);
    else
      Icr.wf = Regs[r2];
    iop2 = Icr.sintf;
    Icr.wf = Regs[r1];
    iop1 = Icr.sintf;
    switch (opcode)
    {

    case INDENT:
      ans = -iop2;
      break;

    case IA:
      ans = iop1 + iop2;
      break;

    case IS:
      ans = iop1 - iop2;
      break;

    case IM:
      ans = iop1 * iop2;
      break;

    case ID:
      ans = iop1 / iop2;
      break;

    case IC:
      ans = iop1;
      Lt = false;
      Eq = false;
      Gt = false;
      if (iop1 < iop2)
	Lt = true;
      else if (iop1 == iop2)
	Eq = true;
      else
	Gt = true;
      break;
    }
    Icr.sintf = ans;
    Regs[r1] = Icr.wf;
    return;
  }
  if ((unsigned)opcode < 32 &&
      ((1L << opcode) & ((1L << FN) | (1L << FA) | (1L << FS) | (1L << FM) |
			 (1L << FD) | (1L << FC))) != 0)
  { wordtobytes(Regs[r1], &Rcr.U99.b1, &Rcr.U99.b4);
    wordtobytes(Regs[(r1 + 1) & (REGSIZ - 1)], &Rcr.U99.b5, &Rcr.U99.b6);
    Rcr.U99.b2 = 0;
    Rcr.U99.b3 = 0;
    rop1 = Rcr.rf;
    if (addr >= 0)
    { Rcr.U99.b1 = Mem[addr];
      Rcr.U99.b4 = Mem[addr + 1];
      Rcr.U99.b5 = Mem[addr + 2];
      Rcr.U99.b6 = Mem[addr + 3];
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    } else {
      wordtobytes(Regs[r2], &Rcr.U99.b1, &Rcr.U99.b4);
      wordtobytes(Regs[(r2 + 1) & (REGSIZ - 1)], &Rcr.U99.b5, &Rcr.U99.b6);
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    }
    rop2 = Rcr.rf;
    switch (opcode)
    {

    case FN:
      rop1 = -rop2;
      break;

    case FA:
      rop1 += rop2;
      break;

    case FS:
      rop1 -= rop2;
      break;

    case FM:
      rop1 *= rop2;
      break;

    case FD:
      rop1 /= rop2;
      break;

    case FC:
      Lt = false;
      Eq = false;
      Gt = false;
      if (rop1 < rop2)
	Lt = true;
      else if (rop1 == rop2)
	Eq = true;
      else
	Gt = true;
      break;
    }
    Rcr.rf = rop1;
    bytestoword(Rcr.U99.b1, Rcr.U99.b4, &Regs[r1]);
    bytestoword(Rcr.U99.b5, Rcr.U99.b6, &Regs[(r1 + 1) & (REGSIZ - 1)]);
    return;
  }
  if ((unsigned)opcode < 32 &&
      ((1L << opcode) & ((1L << BI) | (1L << BO) | (1L << BA))) != 0)
  { if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &wd);
    else
      wd = Regs[r2];
    switch (opcode)
    {

    case BI:
      Regs[r1] = 0;
      for (i = 0; i <= 15; i++)
      { if ((unsigned)i >= 32 || ((1L << i) & wd) == 0)
	  Regs[r1] |= 1L << i;
      }
      break;

    case BO:
      Regs[r1] |= wd;
      break;

    case BA:
      Regs[r1] &= wd;
      break;
    }
    return;
  }
  if (opcode == JSR)
  { Icr.sintf = Pc;
    Regs[r1] = Icr.wf;
    if (addr >= 0)
      Pc = addr;
    else {
      printf("JSR to a Register %ld\n", Pc - 2);
      StopProgram = true;
    }
    return;
  }
  if (opcode == BKT)
  { if (addr < 0)
    { printf("Address of BKT is a Register %ld\n", Pc - 2);
      StopProgram = true;
      return;
    }
    Icr.wf = Regs[r1];
    iop2 = Icr.sintf;
    Icr.wf = Regs[(r1 + 1) & (REGSIZ - 1)];
    FORLIM = Icr.sintf;
    for (i = 0; i < FORLIM; i++)
      Mem[(addr + i) % MEMSIZ] = Mem[(iop2 + i) % MEMSIZ];
    return;
  }
  if (opcode == LD)
  { if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Regs[r1]);
    else
      Regs[r1] = Regs[r2];
    return;
  }
  if (opcode == STO)
  { if (addr < 0)
    { Regs[r2] = Regs[r1];
      return;
    }
    wordtobytes(Regs[r1], &Mem[addr], &Mem[addr + 1]);
    if (Trace)
    { bytestoword(Mem[addr], Mem[addr + 1], &Icr.wf);
      printf("***** value %ld stored at location %d\n", Icr.sintf, addr);
    }
    return;
  }
  if (opcode == LDA)
  { if (addr >= 0)
    { Icr.sintf = addr;
      Regs[r1] = Icr.wf;
    } else {
      printf("Address of LDA is a Register %ld\n", Pc - 2);
      StopProgram = true;
    }
    return;
  }
  if (opcode == FLT)
  { if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Icr.wf);
    else
      Icr.wf = Regs[r2];
    Rcr.rf = Icr.sintf;
    bytestoword(Rcr.U99.b1, Rcr.U99.b4, &Regs[r1]);
    bytestoword(Rcr.U99.b5, Rcr.U99.b6, &Regs[(r1 + 1) & (REGSIZ - 1)]);
    return;
  }
  if (opcode == FIX)
  { if (addr >= 0)
    { Rcr.U99.b1 = Mem[addr];
      Rcr.U99.b4 = Mem[addr + 1];
      Rcr.U99.b5 = Mem[addr + 2];
		Rcr.U99.b6 = Mem[addr + 3];
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    } else {
      wordtobytes(Regs[r2], &Rcr.U99.b1, &Rcr.U99.b4);
      wordtobytes(Regs[(r2 + 1) & (REGSIZ - 1)], &Rcr.U99.b5, &Rcr.U99.b6);
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    }
	 Icr.sintf = Rcr.rf + .5; /*round(Rcr.rf); */
    Regs[r1] = Icr.wf;
    return;
  }
  if (opcode != TRNG)
    return;
  if (addr < 0)
  { printf("Address of TRNG is a register at %ld\n", Pc - 2);
    StopProgram = true;
    return;
  }
  bytestoword(Mem[addr], Mem[addr + 1], &Icr.wf);
  iop1 = Icr.sintf;
  bytestoword(Mem[addr + 2], Mem[addr + 3], &Icr.wf);
  iop2 = Icr.sintf;
  Icr.wf = Regs[r1];
  ans = Icr.sintf;
  if (ans < iop1 || ans > iop2)
  { printf("Index expression out of bounds at %ld (expr = %d lower = %d upper = %d)\n",
	   Pc - 2, ans, iop1, iop2);
    StopProgram = true;
  }
}


Static void jop(short jmode, short amode, short reg, short *w2)
{ short addr;

  addr = eac(amode, reg, w2);
  if (addr < 0)
  { printf("Jump to a Register %ld\n", Pc - 2);
    StopProgram = true;
    return;
  }
  if ((unsigned)jmode >= 32 || ((1L << jmode) & 0xff) == 0)
  { printf("Invalid Jump Mode %ld\n", Pc - 2);
    StopProgram = true;
    return;
  }
  switch (jmode)
  {

  case 0:
    Pc = addr;
    break;

  case 1:
    if (Lt)
      Pc = addr;
    break;

  case 2:
    if (Lt || Eq)
      Pc = addr;
    break;

  case 3:
    if (Eq)
      Pc = addr;
    break;

  case 4:
    if (!Eq)
      Pc = addr;
    break;

  case 5:
    if (Gt || Eq)
      Pc = addr;
    break;

  case 6:
    if (Gt)
      Pc = addr;
    break;

  case 7:
    /* blank case */
    break;
  }
}


Static void srop(short reg, short smode, short amnt)
{ word w1, w2, w3;
  short i, j;
  boolean flag;
  long SET[1025], SET1[1025], SET2[1025];
  long SET3[257], SET4[257], SET5[257];

  switch (smode)
  {

  case 0:
    w1 = Regs[reg];
    if (amnt == 0)
      w1 = 0;
    else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 15 - i; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	w1 = P_packset(P_setdiff(SET5, P_expset(SET4, w1),
				 P_addset(P_expset(SET3, 0), 16 - i)));
      }
    }
    Regs[reg] = w1;
    break;

  case 1:
    w1 = Regs[reg];
    if (amnt == 0)
      w1 = 0xffffffff;
    else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 15 - i; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	w1 |= 1L << (16 - i);
      }
    }
    Regs[reg] = w1;
    break;

  case 2:
    w1 = Regs[reg];
    if (amnt == 0)
    { if ((0xffff8000L & w1) != 0)
	w1 = 0xffffffff;
      else
	w1 = 0;
    } else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 14; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
      }
    }
    Regs[reg] = w1;
    break;

  case 3:
    w1 = Regs[reg];
    if (amnt != 0)
    { for (i = 1; i <= amnt; i++)
      { flag = ((0x1 & w1) != 0);
	for (j = 0; j <= 14; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	if (flag)
	  w1 |= 0xffff8000L;
	else
	  w1 &= ~0xffff8000L;
      }
    }
    Regs[reg] = w1;
    break;

  case 4:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w2 = w1;
      w1 = 0;
    } else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 14; j++)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w2) != 0)
	    w2 |= 1L << j;
	}
	if ((0x1 & w1) != 0)
	  w2 |= 0xffff8000L;
	else
	  w2 &= ~0xffff8000L;
	for (j = 0; j <= 15 - i; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	w1 = P_packset(P_setdiff(SET5, P_expset(SET3, w1),
				 P_addset(P_expset(SET4, 0), 16 - i)));
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 5:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w2 = w1;
      w1 = 0xffffffff;
    } else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 14; j++)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w2) != 0)
	    w2 |= 1L << j;
	}
	if ((0x1 & w1) != 0)
	  w2 |= 0xffff8000L;
	else
	  w2 &= ~0xffff8000L;
	for (j = 0; j <= 15 - i; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	w1 |= 1L << (16 - i);
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 6:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w2 = w1;
      if ((0xffff8000L & w2) != 0)
	w1 = 0xffffffff;
      else
	w1 = 0;
    } else {
      for (i = 1; i <= amnt; i++)
      { for (j = 0; j <= 14; j++)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w2) != 0)
	    w2 |= 1L << j;
	}
	if ((0x1 & w1) != 0)
	  w2 |= 0xffff8000L;
	else
	  w2 &= ~0xffff8000L;
	for (j = 0; j <= 15 - i; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 7:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w3 = w2;
      w2 = w1;
      w1 = w3;
    } else {
      for (i = 1; i <= amnt; i++)
      { flag = ((0x1 & w2) != 0);
	for (j = 0; j <= 14; j++)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w2) != 0)
	    w2 |= 1L << j;
	}
	if ((0x1 & w1) != 0)
	  w2 |= 0xffff8000L;
	else
	  w2 &= ~0xffff8000L;
	for (j = 0; j <= 14; j++)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j)));
	  if (j >= -1 && j < 31 && ((1L << (j + 1)) & w1) != 0)
	    w1 |= 1L << j;
	}
	if (flag)
	  w1 |= 0xffff8000L;
	else
	  w1 &= ~0xffff8000L;
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;
  }
}


Static void slop(short reg, short smode, short amnt)
{ word w1, w2, w3;
  short i, j;
  boolean flag;
  long SET[257], SET1[257], SET2[257];

  switch (smode)
  {

  case 0:
    w1 = Regs[reg];
    if (amnt == 0)
      w1 = 0;
    else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= i; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				 P_addset(P_expset(SET1, 0), i)));
      }
    }
    Regs[reg] = w1;
    break;

  case 1:
    w1 = Regs[reg];
    if (amnt == 0)
      w1 = 0xffffffff;
    else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= i; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	w1 |= 1L << i;
      }
    }
    Regs[reg] = w1;
    break;

  case 2:
    w1 = Regs[reg];
    if (amnt == 0)
    { if ((0x1 & w1) != 0)
	w1 = 0xffffffff;
      else
	w1 = 0;
    } else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= i; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
      }
    }
    Regs[reg] = w1;
    break;

  case 3:
    w1 = Regs[reg];
    if (amnt != 0)
    { for (i = 1; i <= amnt; i++)
      { flag = ((0xffff8000L & w1) != 0);
	for (j = 14; j >= 0; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	if (flag)
	  w1 |= 0x1;
	else
	  w1 &= ~0x1;
      }
    }
    Regs[reg] = w1;
    break;

  case 4:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w1 = w2;
      w2 = 0;
    } else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= 0; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	if ((0xffff8000L & w2) != 0)
	  w1 |= 0x1;
	else
	  w1 &= ~0x1;
	for (j = 14; j >= i; j--)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w2) != 0)
	    w2 |= 1L << (j + 1);
	}
	w2 = P_packset(P_setdiff(SET2, P_expset(SET, w2),
				 P_addset(P_expset(SET1, 0), i)));
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 5:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w1 = w2;
      w2 = 0xffffffff;
    } else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= 0; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET, w1),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	if ((0xffff8000L & w2) != 0)
	  w1 |= 0x1;
	else
	  w1 &= ~0x1;
	for (j = 14; j >= i; j--)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET1, w2),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w2) != 0)
	    w2 |= 1L << (j + 1);
	}
	w2 |= 1L << i;
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 6:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w1 = w2;
      if ((0x1 & w2) != 0)
	w2 = 0xffffffff;
      else
	w2 = 0;
    } else {
      for (i = 0; i < amnt; i++)
      { for (j = 14; j >= 0; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	if ((0xffff8000L & w2) != 0)
	  w1 |= 0x1;
	else
	  w1 &= ~0x1;
	for (j = 14; j >= i; j--)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET, w2),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w2) != 0)
	    w2 |= 1L << (j + 1);
	}
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;

  case 7:
    w1 = Regs[reg];
    w2 = Regs[(reg + 1) & (REGSIZ - 1)];
    if (amnt == 0)
    { w3 = w1;
      w1 = w2;
      w2 = w3;
    } else {
      for (i = 1; i <= amnt; i++)
      { flag = ((0xffff8000L & w1) != 0);
	for (j = 14; j >= 0; j--)
	{ w1 = P_packset(P_setdiff(SET2, P_expset(SET1, w1),
				   P_addset(P_expset(SET, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w1) != 0)
	    w1 |= 1L << (j + 1);
	}
	if ((0xffff8000L & w2) != 0)
	  w1 |= 0x1;
	else
	  w1 &= ~0x1;
	for (j = 14; j >= 0; j--)
	{ w2 = P_packset(P_setdiff(SET2, P_expset(SET, w2),
				   P_addset(P_expset(SET1, 0), j + 1)));
	  if ((unsigned)j < 32 && ((1L << j) & w2) != 0)
	    w2 |= 1L << (j + 1);
	}
	if (flag)
	  w2 |= 0x1;
	else
	  w2 &= ~0x1;
      }
    }
    Regs[reg] = w1;
    Regs[(reg + 1) & (REGSIZ - 1)] = w2;
    break;
  }
}


Static void rdop(short rmode, short amode, short reg, short *w2)
{ word wd;
  boolean flag;
  short addr, i, ival;
  Char ch;
  long SET[1025], SET1[1025], SET2[1025];

  if ((unsigned)rmode >= 32 || ((1L << rmode) & 0xfff) == 0)
  { printf("Invalid Read Mode Detected at %ld\n", Pc - 2);
    StopProgram = true;
    return;
  }
  addr = eac(amode, reg, w2);
  switch (rmode)
  {

  case 0:
    scanf("%hd", &i);
    if (i > SHORT_MAX || i < -SHORT_MAX)
    { printf("Invalid Input: RDI %ld\n", Pc - 2);
      StopProgram = true;
    } else {
      Icr.sintf = i;
      if (addr >= 0)
	wordtobytes(Icr.wf, &Mem[addr], &Mem[addr + 1]);
      else
	Regs[reg] = Icr.wf;
    }
    break;

  case 1:
    scanf("%lg", &Rcr.rf);
    if (addr >= 0)
    { Mem[addr] = Rcr.U99.b1;
      Mem[addr + 1] = Rcr.U99.b4;
      Mem[addr + 2] = Rcr.U99.b5;
      Mem[addr + 3] = Rcr.U99.b6;
    } else {
      bytestoword(Rcr.U99.b1, Rcr.U99.b4, &Regs[reg]);
      bytestoword(Rcr.U99.b5, Rcr.U99.b6, &Regs[(reg + 1) & (REGSIZ - 1)]);
    }
    break;

  case 2:
    ch = getchar();
    if (ch == '0')
    { if (addr >= 0)
	Mem[addr] &= ~0x80;
      else
	Regs[addr] &= ~0xffff8000L;
    } else if (ch == '1')
    { if (addr >= 0)
	Mem[addr] |= 0x80;
      else
	Regs[addr] |= 0xffff8000L;
    } else {
      printf("Invalid Input: RDBD %ld\n", Pc - 2);
      StopProgram = true;
    }
    break;

  case 3:
    i = 15;
    flag = true;
    while (i >= 0 && flag)
    { ch = getchar();
      if (ch == '1')
	wd |= 1L << i;
      else if (ch == '0')
	wd = P_packset(P_setdiff(SET2, P_expset(SET, wd),
				 P_addset(P_expset(SET1, 0), i)));
      else {
	printf("Invalid Input: RDBW %ld\n", Pc - 2);
	flag = false;
	StopProgram = true;
      }
      i--;
    }
    if (flag)
    { if (addr >= 0)
	wordtobytes(wd, &Mem[addr], &Mem[addr + 1]);
      else
	Regs[reg] = wd;
    }
    break;

  case 4:
  case 5:
    printf("Operations RDOD and RDOW not presentlyimplemented, at %ld\n",
	   Pc - 2);
    StopProgram = true;
    break;

  case 6:
    ch = getchar();
    if (ch >= 'a' && ch <= 'f' || ch >= 'A' && ch <= 'F' || isdigit(ch))
    { switch (ch)
      {

      case 'A':
      case 'a':
	wd = 0xffffa000;
	break;

      case 'B':
      case 'b':
	wd = 0xffffb000;
	break;

      case 'C':
      case 'c':
	wd = 0xffffc000;
	break;

      case 'D':
      case 'd':
	wd = 0xffffd000;
	break;

      case 'E':
      case 'e':
	wd = 0xffffe000;
	break;

      case 'F':
      case 'f':
	wd = 0xfffff000;
	break;

      case '0':
	wd = 0;
	break;

      case '1':
	wd = 0x1000;
	break;

      case '2':
	wd = 0x2000;
	break;

      case '3':
	wd = 0x3000;
	break;

      case '4':
	wd = 0x4000;
	break;

      case '5':
	wd = 0x5000;
	break;

      case '6':
	wd = 0x6000;
	break;

      case '7':
	wd = 0x7000;
	break;

      case '8':
	wd = 0xffff8000L;
	break;

      case '9':
	wd = 0xffff9000;
	break;
      }
      if (addr < 0)
      { Regs[reg] &= ~0xfffff000;
	Regs[reg] |= wd;
      }
    } else {
      printf("Invalid Input: RDHD %ld\n", Pc - 2);
      StopProgram = true;
    }
    break;

  case 7:
    i = 15;
    flag = true;
    wd = 0;
    while (i >= 1 && flag)
    { ch = getchar();
      if (ch >= 'A' && ch <= 'F')
	ival = ch + 10 - 'A';
      else if (ch >= 'a' && ch <= 'f')
	ival = ch + 10 - 'a';
      else if (isdigit(ch))
	ival = ch - '0';
      else {
	printf("Invalid Input: RDHW %ld\n", Pc - 2);
	flag = false;
	StopProgram = true;
      }
      if (!flag)
	break;
      if (ival > 7)
      { wd |= 1L << i;
	ival -= 7;
      }
      i--;
      if (ival > 3)
      { wd |= 1L << i;
	ival -= 3;
      }
      i--;
      if (ival > 1)
      { wd |= 1L << i;
	ival--;
      }
      i--;
      if (ival > 0)
	wd |= 1L << i;
      i--;
    }
    if (addr >= 0)
      wordtobytes(wd, &Mem[addr], &Mem[addr + 1]);
    else
      Regs[reg] = wd;
    break;

  case 8:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Ccr.wf);
    else
      Ccr.wf = Regs[reg];
    Ccr.U1.c1 = getchar();
    if (addr >= 0)
      wordtobytes(Ccr.wf, &Mem[addr], &Mem[addr + 1]);
    else
      Regs[reg] = Ccr.wf;
    break;

  case 9:
    if (addr < 0)
    { printf("Invalid Address: RDST %ld\n", Pc - 2);
      StopProgram = true;
    } else {
      flag = true;
      while (!P_eoln(stdin))
      { if (flag)
	{ flag = false;
	  Ccr.U1.c1 = getchar();
	} else {
	  flag = true;
	  Ccr.U1.c2 = getchar();
	  wordtobytes(Ccr.wf, &Mem[addr], &Mem[addr + 1]);
	  addr = (addr + 2) % MEMSIZ;
	}
      }
      if (flag)
	Ccr.U1.c1 = '\0';
      else
	Ccr.U1.c2 = '\0';
      wordtobytes(Ccr.wf, &Mem[addr], &Mem[addr + 1]);
    }
    scanf("%*[^\n]");
    getchar();
    break;

  case 10:
    printf("Operation RDIN not presently implemented, at %ld\n", Pc - 2);
    StopProgram = true;
    break;

  case 11:
    scanf("%*[^\n]");
    getchar();
    break;
  }
}


Static void wrop(short wmode, short amode, short reg, short *w2)
{ short addr, ival, bval, i;
  word wd;
  Char ch;

  if ((unsigned)wmode >= 32 || ((1L << wmode) & 0xbff) == 0)
  { printf("Invalid Write Mode Dectected at %ld\n", Pc - 1);
    StopProgram = true;
    return;
  }
  addr = eac(amode, reg, w2);
  switch (wmode)
  {

  case 0:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Icr.wf);
    else
      Icr.wf = Regs[reg];
    printf("%ld", Icr.sintf);
    break;

  case 1:
    if (addr >= 0)
    { Rcr.U99.b1 = Mem[addr];
      Rcr.U99.b4 = Mem[addr + 1];
      Rcr.U99.b5 = Mem[addr + 2];
      Rcr.U99.b6 = Mem[addr + 3];
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    } else {
      wordtobytes(Regs[reg], &Rcr.U99.b1, &Rcr.U99.b4);
      wordtobytes(Regs[(reg + 1) & (REGSIZ - 1)], &Rcr.U99.b5, &Rcr.U99.b6);
      Rcr.U99.b2 = 0;
      Rcr.U99.b3 = 0;
    }
    printf("% .5E", Rcr.rf);
    break;

  case 2:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &wd);
    else
      wd = Regs[reg];
    if ((0xffff8000L & wd) != 0)
      putchar('1');
    else
      putchar('0');
    break;

  case 3:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &wd);
    else
      wd = Regs[reg];
    for (i = 0; i <= 15; i++)
    { if ((unsigned)i < 32 && ((1L << i) & wd) != 0)
	putchar('1');
      else
	putchar('0');
    }
    break;

  case 4:
  case 5:
    printf("Operations WROD and WROW not presentlyimplemented, at %ld\n",
	   Pc - 2);
    StopProgram = true;
    break;

  case 6:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &wd);
    else
      wd = Regs[reg];
    bval = 8;
    ival = 0;
    for (i = 15; i >= 12; i--)
    { if ((unsigned)i < 32 && ((1L << i) & wd) != 0)
	ival += bval;
      bval /= 2;
    }
    printf("%d", ival);
    break;

  case 7:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &wd);
    else
      wd = Regs[reg];
    bval = SHORT_MAX;
    ival = 0;
    for (i = 15; i >= 0; i--)
    { if ((unsigned)i < 32 && ((1L << i) & wd) != 0)
	ival += bval;
      bval /= 2;
    }
    if (ival < 4096)
      putchar('0');
    if (ival < 256)
      putchar('0');
    if (ival < 16)
      putchar('0');
    printf("%d", ival);
    break;

  case 8:
    if (addr >= 0)
      bytestoword(Mem[addr], Mem[addr + 1], &Ccr.wf);
    else
      Ccr.wf = Regs[reg];
    putchar(Ccr.U1.c1);
    break;

  case 9:
    ch = ' ';
    while (ch != 0)
    { if (addr >= 0)
      { bytestoword(Mem[addr], Mem[addr + 1], &Ccr.wf);
	addr = (addr + 2) % MEMSIZ;
      } else {
	Ccr.wf = Regs[reg];
	reg = (reg + 1) & (REGSIZ - 1);
      }
      if (Ccr.U1.c1 == 0)
      { ch = '\0';
	break;
      }
      putchar(Ccr.U1.c1);
      if (Ccr.U1.c2 != 0)
	putchar(Ccr.U1.c2);
      else
	ch = '\0';
    }
    break;

  case 11:
    putchar('\n');
    break;
  }
}


Static void execute()
{ short opcode, f1, f2, f3, w2;

  opcode = 0;
  if ((0xffff8000L & Ir) != 0)
    opcode = 16;
  if ((0x4000 & Ir) != 0)
    opcode += 8;
  if ((0x2000 & Ir) != 0)
    opcode += 4;
  if ((0x1000 & Ir) != 0)
    opcode += 2;
  if ((0x800 & Ir) != 0)
    opcode++;
  f1 = 0;
  if ((0x400 & Ir) != 0)
    f1 = 8;
  if ((0x200 & Ir) != 0)
    f1 += 4;
  if ((0x100 & Ir) != 0)
    f1 += 2;
  if ((0x80 & Ir) != 0)
    f1++;
  f2 = 0;
  if ((0x40 & Ir) != 0)
    f2 = 4;
  if ((0x20 & Ir) != 0)
    f2 += 2;
  if ((0x10 & Ir) != 0)
    f2++;
  f3 = 0;
  if ((0x8 & Ir) != 0)
    f3 = 8;
  if ((0x4 & Ir) != 0)
    f3 += 4;
  if ((0x2 & Ir) != 0)
    f3 += 2;
  if ((0x1 & Ir) != 0)
    f3++;
  w2 = 0;
  switch (opcode)
  {

  case INDENT:
  case IA:
  case IS:
  case IM:
  case ID:
  case FN:
  case FA:
  case FS:
  case FM:
  case FD:
  case BI:
  case BO:
  case BA:
  case IC:
  case FC:
  case JSR:
  case BKT:
  case LD:
  case STO:
  case LDA:
  case FIX:
  case FLT:
  case TRNG:
    twoaddr(opcode, f1, f2, f3, &w2);
    break;

  case J:
    jop(f1, f2, f3, &w2);
    break;

  case SR:
    srop(f1, f2, f3);
    break;

  case SL:
    slop(f1, f2, f3);
    break;

  case RD:
    rdop(f1, f2, f3, &w2);
    break;

  case WR:
    wrop(f1, f2, f3, &w2);
    break;

  case HALT:
    StopProgram = true;
    break;

  case 28:
  case 29:
  case 30:
    printf("Bad opcode%ld\n", Pc - 2);
    StopProgram = true;
    break;
  }
  if (!Trace)
    return;
  printf("----------------------------------------\n");
  writeinst(oldPc, opcode, f1, f2, f3, w2);
  printf("----------------------------------------\n");
  displayregs();
}


Static void rdmem()
{ FILE *memf;
  short i;
  Char memf_NAME[_FNSIZE];

  memf = NULL;
  strcpy(memf_NAME, "OBJ");
  if (memf != NULL)
    memf = freopen(memf_NAME, "r+b", memf);
  else
    memf = fopen(memf_NAME, "r+b");
  if (memf == NULL)
    _EscIO(FileNotFound);
  if (P_eof(memf))
    MemImage = false;
  i = 0;
  while (!P_eof(memf))
  { fread(&Bcr.hintf, sizeof(byterange), 1, memf);
    Mem[i] = Bcr.bytef;
    i++;
  }
  if (memf != NULL)
    fclose(memf);
}


Static void GetCommand(int argc, Char *argv[])
{ short I, J_;
  Char S[256];
  Char STR[256];
  short FORLIM1;
  //CLZ changed comparison from I <= argc
  for (I = 1; I < argc; I++)
  { 
    
    strcpy(S, argv[I]);
    
    
    if (S[0] == '/')
	 { FORLIM1 = strlen(S);
		for (J_ = 1; J_ < FORLIM1; J_++)
		{ switch (S[J_])
	{

	case 'D': case 'd':
	  Dump = true;
	  break;

	case 'T': case 't':
	  Trace = true;
	  break;

	default:
	  printf("Invalid option: %c\n", S[J_]);
	  break;
	}
      }
    }
  }
}


main(int argc, Char *argv[])
{ PASCAL_MAIN(argc, argv);
  Dumpf = NULL;
  MemImage = true;
  Dump = false;
  Trace = false;
  //printf("\nRight before GetCommand\n");
    GetCommand(argc, argv);
  //printf("\nRight after GetCommand\n");
  rdmem();
  //printf("\nRight after rdmem\n");
  Lt = false;
  Eq = false;
  Gt = false;
  Pc = 0;
  StopProgram = false;
  if (MemImage)
  { for (RegIndex = 0; RegIndex <= 15; RegIndex++)
      Regs[RegIndex] = 0;
    do
    { oldPc = Pc;
      fetchword(&Ir);
      execute();
      if (Trace)
      { printf("\nPress <ENTER> to contine.\n");
	scanf("%*[^\n]");
	getchar();
	putchar('\n');
      }
    } while (!StopProgram);
  }
  if (Dump)
  { strcpy(Dumpf_NAME, "DUMPFILE");
    if (Dumpf != NULL)
      Dumpf = freopen(Dumpf_NAME, "w+b", Dumpf);
    else
      Dumpf = fopen(Dumpf_NAME, "w+b");
    if (Dumpf == NULL)
      _EscIO(FileNotFound);
    for (i = 1; i < MEMSIZ; i++)
    { Bcr.bytef = Mem[i];
      fwrite(&Bcr.hintf, sizeof(byterange), 1, Dumpf);
    }
  }
  if (Dumpf != NULL)
    fclose(Dumpf);
  exit(EXIT_SUCCESS);
}



/* End. */

